Loading...
Searching...
No Matches
OBOrbitalData Class Reference

`#include <openbabel/generic.h>`

Inheritance diagram for OBOrbitalData:
[legend]

## Public Member Functions

| OBOrbitalData ()
virtual | ~OBOrbitalData ()
virtual OBGenericData * | Clone (OBBase *) const
OBOrbitalData & | operator= (const OBOrbitalData &)
void | SetAlphaOrbitals (std::vector< OBOrbital > orbitalList)
void | SetBetaOrbitals (std::vector< OBOrbital > orbitalList)
void | SetHOMO (int alpha, int beta=0)
void | SetOpenShell (bool openShell)
bool | IsOpenShell ()
unsigned int | GetAlphaHOMO ()
unsigned int | GetBetaHOMO ()
std::vector< OBOrbital > | GetAlphaOrbitals ()
std::vector< OBOrbital > | GetBetaOrbitals ()
void | LoadClosedShellOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, unsigned int alphaHOMO)
void | LoadAlphaOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, unsigned int alphaHOMO)
void | LoadBetaOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, unsigned int betaHOMO)
void | SetAttribute (const std::string &v)
void | SetOrigin (const DataOrigin s)
virtual const std::string & | GetAttribute () const
unsigned int | GetDataType () const
virtual const std::string & | GetValue () const
virtual DataOrigin | GetOrigin () const

## Protected Attributes

std::vector< OBOrbital > | _alphaOrbitals
std::vector< OBOrbital > | _betaOrbitals
unsigned int | _alphaHOMO
unsigned int | _betaHOMO
bool | _openShell
std::string | _attr
unsigned int | _type
DataOrigin | _source

## Detailed Description

Used to hold information about orbital energies.

## Constructor & Destructor Documentation

## OBOrbitalData()

OBOrbitalData | ( |  | ) |

inline

Referenced by Clone(), and operator=().

## ~OBOrbitalData()

virtual ~OBOrbitalData | ( |  | ) |

inline virtual

## Member Function Documentation

## Clone()

virtual OBGenericData * Clone | ( | OBBase * |  | ) | const

inline virtual

Reimplemented from OBGenericData.

## operator=()

OBOrbitalData & operator= | ( | const OBOrbitalData & |  | ) |

## SetAlphaOrbitals()

void SetAlphaOrbitals | ( | std::vector< OBOrbital > | orbitalList | ) |

inline

## SetBetaOrbitals()

void SetBetaOrbitals | ( | std::vector< OBOrbital > | orbitalList | ) |

inline

## SetHOMO()

void SetHOMO | ( | int | alpha,
|  | int | beta = 0 )

inline

## SetOpenShell()

void SetOpenShell | ( | bool | openShell | ) |

inline

## IsOpenShell()

bool IsOpenShell | ( |  | ) |

inline

## GetAlphaHOMO()

unsigned int GetAlphaHOMO | ( |  | ) |

inline

## GetBetaHOMO()

unsigned int GetBetaHOMO | ( |  | ) |

inline

## GetAlphaOrbitals()

std::vector< OBOrbital > GetAlphaOrbitals | ( |  | ) |

inline

## GetBetaOrbitals()

std::vector< OBOrbital > GetBetaOrbitals | ( |  | ) |

inline

## LoadClosedShellOrbitals()

void LoadClosedShellOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | unsigned int | alphaHOMO )

Convenience function for common cases of closed-shell calculations – pass the energies and symmetries This method will fill the OBOrbital objects for you.

## LoadAlphaOrbitals()

void LoadAlphaOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | unsigned int | alphaHOMO )

Convenience function to load alpha orbitals in an open-shell calculation.

## LoadBetaOrbitals()

void LoadBetaOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | unsigned int | betaHOMO )

Convenience function to load beta orbitals in an open-shell calculation.

## SetAttribute()

void SetAttribute | ( | const std::string & | v | ) |

inline inherited

Set the attribute (key), which can be used to retrieve this data.

Referenced by OBGastChrg::AssignPartialCharges(), OBMol::DoTransformations(), AliasData::Expand(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBForceField::GetAtomTypes(), OBMol::GetFormula(), OBMol::GetLSSR(), OBForceField::GetPartialCharges(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

## SetOrigin()

void SetOrigin | ( | const DataOrigin | s | ) |

inline inherited

Set the origin of this data, which can be used to filter the data.

Referenced by OBGastChrg::AssignPartialCharges(), OBMol::DoTransformations(), OBMol::FindAngles(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBMol::FindTorsions(), OBMol::GetFormula(), OBMol::GetLSSR(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

## GetAttribute()

virtual const std::string & GetAttribute | ( |  | ) | const

inline virtual inherited

Returns
  The attribute (key), which can be used to retrieve this data

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

## GetDataType()

unsigned int GetDataType | ( |  | ) | const

inline inherited

Returns
  the data type for this object as defined in OBGenericDataType

## GetValue()

virtual const std::string & GetValue | ( |  | ) | const

inline virtual inherited

Base class returns a default value (the attribute type) but should never be called.

Reimplemented in OBCommentData, and OBPairData.

Referenced by OBDepict::DrawMolecule(), OBDescriptor::FilterCompare(), and OBDescriptor::GetValues().

## GetOrigin()

virtual DataOrigin GetOrigin | ( |  | ) | const

inline virtual inherited

## Member Data Documentation

## _alphaOrbitals

std::vector<OBOrbital> _alphaOrbitals

protected

List of orbitals. In case of unrestricted calculations, this contains the alpha spin-orbitals.

Referenced by GetAlphaOrbitals(), LoadAlphaOrbitals(), LoadClosedShellOrbitals(), and SetAlphaOrbitals().

## _betaOrbitals

std::vector<OBOrbital> _betaOrbitals

protected

Only used if needed (e.g., unrestricted calculations).

Referenced by GetBetaOrbitals(), LoadBetaOrbitals(), LoadClosedShellOrbitals(), and SetBetaOrbitals().

## _alphaHOMO

unsigned int _alphaHOMO

protected

Highest occupied molecular orbital for _alphaOrbitals.

Referenced by GetAlphaHOMO(), LoadAlphaOrbitals(), LoadClosedShellOrbitals(), OBOrbitalData(), and SetHOMO().

## _betaHOMO

unsigned int _betaHOMO

protected

Highest occupied for _betaOrbitals (if needed).

Referenced by GetBetaHOMO(), LoadBetaOrbitals(), LoadClosedShellOrbitals(), OBOrbitalData(), and SetHOMO().

## _openShell

bool _openShell

protected

Whether we store both alpha and beta spin-orbitals (i.e., a restricted open-shell or unrestricted calc.).

Referenced by IsOpenShell(), LoadAlphaOrbitals(), LoadBetaOrbitals(), LoadClosedShellOrbitals(), OBOrbitalData(), and SetOpenShell().

## _attr

std::string _attr

protected inherited

attribute tag (e.g., "UnitCell", "Comment" or "Author")

Referenced by OBRotamerList::Clone(), GetAttribute(), GetValue(), OBGenericData(), OBNasaThermoData::OBNasaThermoData(), OBRotamerList::OBRotamerList(), OBSymmetryData::OBSymmetryData(), and SetAttribute().

## _type

unsigned int _type

protected inherited

attribute type – declared for each subclass

Referenced by OBRotamerList::Clone(), GetDataType(), OBGenericData(), OBNasaThermoData::OBNasaThermoData(), OBRotamerList::OBRotamerList(), and OBSymmetryData::OBSymmetryData().

## _source

DataOrigin _source

protected inherited

source of data for accounting

Referenced by GetOrigin(), OBGenericData(), OBSymmetryData::OBSymmetryData(), OBAngleData::operator=(), OBConformerData::operator=(), OBSymmetryData::operator=(), OBTorsionData::operator=(), and SetOrigin().

The documentation for this class was generated from the following files:

- generic.h
- generic.cpp